﻿using System;
using System.Globalization;
using System.Linq;
using System.Windows.Data;
using System.Collections.ObjectModel;
using System.Collections;

namespace SelfReferenceHierarchyTreeViewWPF
{
	public class HierarchyConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			// We are binding an item
			DataItem item = value as DataItem;
			if (item != null)
			{
				var result = new ParentAwareCollection<DataItem>(item.ID);
				foreach (DataItem child in item.Owner.OfType<DataItem>().Where(i => i.ParentID == item.ID))
				{
					result.Add(child);
				}
				return result;
			}

			// We are binding the treeview
			IList items = value as IList;
			if (items != null)
			{
				var result = new ParentAwareCollection<DataItem>(0);
				foreach (DataItem child in items.OfType<DataItem>().Where(i => i.ParentID == 0))
				{
					result.Add(child);
				}
				return result;
			}

			return null;
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}